#include <stdlib.h>
#include <stdio.h>

void help(const char *prg)
{
	printf("ud - universal dump\n");
	printf("Usage: %s [options] [flags]\n", prg);
	printf("Note: input is always read from stdin.\n");
	printf("Options are specified in \"name=val\" or \"name val\" format; name may\nbe preceded by optional dash characters.\n");
	printf(" --cols=int           override width of the terminal; alias: -c\n");
	printf(" --data_cols=int      number of bytes to be displayed per line; alias: -d\n");
	printf(" --col_hdr_width=int  width of the offset display column; alias: -H\n");
	printf(" --word_size=int      gap after word_size bytes in the table; alias: -w\n");
	printf(" --printable=0|1      display printable ASCII (column 3)? alias: -p\n");
	printf(" --interactive=0|1    1 means terminal control and real-time op; alias: -i\n");
	printf(" --fmt=format         data display format (can not be \"none\"); alias: -f\n");
	printf(" --offs=format        offset display format (can be \"none\"); alias: -o\n");
	printf(" --skip=int           skip the first int bytes of input; alias: -s\n");
	printf(" --len=int            stop after printing int bytes of input; alias: -l\n");
	printf(" --output=fn          also dump lines to file fn (overwriting); alias: -O\n");
	printf(" --append=fn          also dump lines to file fn (appending); alias: -A\n");


	printf("Flags are like options but they don't have a value, only a name:\n");
	printf(" --help               this help screen; alias: -h\n");
	printf(" --verbose            increase verbosity level; alias: -v\n");
	printf(" --force              don't think, just do what the user wants; alias: -f\n");
	printf("\nDisplay formats:");
	printf(" binary:      bin, binary, 2");
	printf(" octal:       oct, octal, 8");
	printf(" decimal:     dec, decimal, 10");
	printf(" hexadecimal: hex, hexl, hexadecimal, 16 (lower case letters)");
	printf("              HEX, HEXU, HEXADECIMAL (uppercase case letters)");
	printf(" none:        none, -, off (disables offs column)");
	printf("\nExamples:");
	printf("1. Print data in binary, 4 bytes per line grouped in 2x2 bytes:\n");
	printf(" GNU-style long options:\n");
	printf("  ud --fmt 2 --data_cols 4 --word_size 2\n");
	printf(" UNIX-style short options:\n");
	printf("  ud -f 2 -d 4 -w 2\n");
	printf(" key-value style:\n");
	printf("  ud fmt=2 data_cols=4 word_size=2\n");
	printf("\n");
	printf("2. Print data in octal, 8 bytes per line, and nothing else:\n");
	printf("  ud fmt=octal data_cols=8 word_size=0 printable=0 offs=none\n");
	printf("\n");
	exit(0);
}
